----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    12:58:31 12/03/2009 
-- Design Name: 
-- Module Name:    top_module_phase2b - arch
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 

-- Version 2p0 06/01/2012
-- Added the Quadrature ADC checks
-- If any quadrature ADC value falls below 50,000 then the controller throws an error

----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;
use work.sercon_types.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity top_module_phase2b is
    Port ( 
			clk 								: in std_logic;
         reset 							: in std_logic;
			
			C_I_ch_a							: in std_logic;
			C_I_ch_b							: in std_logic;
			C_I_index						: in std_logic;
			
			C_I_key_en						: in std_logic;
			C_I_isis_ms						: in std_logic;
			C_I_mice_daq_ok				: in std_logic;
			
			C_I_tgt_frame_raised			: in std_logic;
			C_I_tgt_frame_lowered 		: in std_logic;
			
			C_I_Function_1_5V				: in std_logic;
			
			C_I_interlock_1_5v			: in std_logic; 
			C_I_interlock_2_5v			: in std_logic; 
			C_I_interlock_3_5v			: in std_logic; 
			C_I_interlock_4_5v			: in std_logic; 
			
			--C_I_interlock_1_24v			: in std_logic; 
			--C_I_interlock_2_24v			: in std_logic;
			C_I_interlock_3_24v			: in std_logic;
			C_I_interlock_4_24v			: in std_logic;
			
			
			-- Test LED's
			reset_led						: out std_logic;
			
			C_O_LED1							: out std_logic;
			C_O_LED2							: out std_logic;
			C_O_LED3							: out std_logic;
			C_O_LED4							: out std_logic;
			C_O_LED5							: out std_logic;
			C_O_LED6							: out std_logic;
			
			C_O_LED_R7						: out std_logic;
			-- Test LED's
					
			C_O_ChA_LED						: out std_logic;
			C_O_ChB_LED						: out std_logic;
			C_O_Indx_LED					: out std_logic;
						
			C_O_mosfet						: out std_logic_vector(6 downto 1);
			C_O_mosfet_led					: out std_logic_vector(6 downto 1);
			C_O_target_pos					: out std_logic_vector(8 downto 0);			
						
			C_O_tgt_ready_50r				: out std_logic;
			
			C_O_parked_led					: out std_logic;
			C_O_hold_led					: out std_logic;
			C_O_sys_en_led					: out std_logic;
			C_O_actuate_en_led			: out std_logic;
			C_O_tgt_ready_led				: out std_logic;
			C_O_actuating_led				: out std_logic;
			C_O_frame_raised_led			: out std_logic;
			C_O_frame_lowered_led 		: out std_logic;		
			C_O_error_led					: out std_logic;
			
			C_O_actuating_50r_1			: out std_logic;
			C_O_actuating_50r_2			: out std_logic;
			C_O_actuating_50r_3			: out std_logic;
			
			C_O_actuating_trig_50r_1	: out std_logic;
			C_O_actuating_trig_50r_2	: out std_logic;
			
			C_O_trig_accept_50r			: out std_logic;
			
			C_O_Frame_Enable_50r			: out std_logic;
			C_O_Legal_Spill_50r			: out std_logic;
			--C_O_unused3						: out std_logic;
			
			C_O_DAQ_tx_dout				: out std_logic;
			C_O_DAQ_tx_sclk				: out std_logic;
			C_O_DAQ_tx_synch				: out std_logic;
			
			C_O_ChA_Epot_tx_dout			: out std_logic;
			C_O_ChA_Epot_tx_sclk			: out std_logic;
			C_O_ChA_Epot_tx_synch		: out std_logic;
			
			C_O_ChB_Epot_tx_dout			: out std_logic;		
			C_O_ChB_Epot_tx_sclk			: out std_logic;
			C_O_ChB_Epot_tx_synch		: out std_logic;
			
			C_O_Indx_Epot_tx_dout		: out std_logic;
			C_O_Indx_Epot_tx_sclk		: out std_logic;
			C_O_Indx_Epot_tx_synch		: out std_logic;
			
			C_I_ChA_ADC_rx_din			: in std_logic;
			C_O_ChA_ADC_rx_sclk			: out std_logic;
			C_O_ChA_ADC_rx_synch			: out std_logic;
			
			C_I_ChB_ADC_rx_din			: in std_logic;		
			C_O_ChB_ADC_rx_sclk			: out std_logic;
			C_O_ChB_ADC_rx_synch			: out std_logic;
			
			C_I_Indx_ADC_rx_din			: in std_logic;
			C_O_Indx_ADC_rx_sclk			: out std_logic;
			C_O_Indx_ADC_rx_synch		: out std_logic;
			
			C_O_Spare_2_50R				: out std_logic;
			C_O_Spare_3_50R				: out std_logic;
			
			C_O_BPS_50R						: out std_logic;
			C_O_BPS_RELAY_1				: out std_logic;
			C_O_BPS_RELAY_2				: out std_logic;
			C_O_BPS_RELAY_3				: out std_logic;
			
			C_O_LASER_RELAY_1				: out std_logic;
			C_O_LASER_RELAY_2				: out std_logic;
			C_O_LASER_RELAY_3				: out std_logic;
			
			C_O_FRAME_EN_RELAY			: out std_logic;
			C_O_SPARE_RELAY				: out std_logic;
			
			--
			-- Usb interface
			--
			sx2_ifclk			: out		std_logic;
			sx2_int				: in		std_logic;
			sx2_ready			: in		std_logic;
			sx2_reset			: out		std_logic;
			sx2_sloe				: out		std_logic;
			sx2_slrd				: out		std_logic;
			sx2_slwr				: out		std_logic;
			sx2_pkt_end			: out		std_logic;
			sx2_fifo_address	: out		std_logic_vector(2 downto 0);
			sx2_flag_a			: in		std_logic;
			sx2_flag_b			: in		std_logic;
			sx2_flag_c			: in		std_logic;
			sx2_wakeup			: out		std_logic;
			sx2_n_cs				: out		std_logic;
			sx2_fifo_data		: inout	std_logic_vector(15 downto 0);
			usb_nc				: in		std_logic				
			);
			
end top_module_phase2b;

architecture arch of top_module_phase2b is

			--USB Register Interconnect Signals
			signal MASTER_clk					: std_logic;
			signal MASTER_reset				: std_logic;
			
			signal MASTER_ControlReg		: std_logic_vector(31 downto 0);
			signal MASTER_SP1Wide			: std_logic_vector(31 downto 0);
			signal MASTER_MTH_Timer			: std_logic_vector(31 downto 0);
			signal MASTER_HoldPosMax		: std_logic_vector(31 downto 0);
			signal MASTER_PWMSetup			: std_logic_vector(31 downto 0);
			signal MASTER_WDTValue			: std_logic_vector(31 downto 0);
			signal MASTER_ISISDelay1		: std_logic_vector(31 downto 0);
			signal MASTER_ISISDelay2		: std_logic_vector(31 downto 0);
			signal MASTER_ErrorCorrection	: std_logic_vector(31 downto 0); -- Includes ECCountMax ECThreshold and DefaultOffset
			signal MASTER_CapSettleTime	: std_logic_vector(31 downto 0);
			signal MASTER_CapWaitTime		: std_logic_vector(31 downto 0);
			signal MASTER_QCSetup			: std_logic_vector(31 downto 0); -- Includes QC InitialPos and QCIndexOffset
			signal MASTER_DeadTime			: std_logic_vector(31 downto 0);
			signal MASTER_KickBackTime		: std_logic_vector(31 downto 0);	
			signal MASTER_DropLimit			: std_logic_vector(31 downto 0);
			signal MASTER_LegalSpillDelay	: std_logic_vector(31 downto 0);
			signal MASTER_ResetRegister	: std_logic_vector(31 downto 0);
			
			signal MASTER_StatusRegister	: std_logic_vector(31 downto 0);			
			signal MASTER_ActuationMinMax : std_logic_vector(31 downto 0);
			signal MASTER_ActuationCount	: std_logic_vector(31 downto 0);
			signal MASTER_ActuationError	: std_logic_vector(31 downto 0);
			signal MASTER_ActuationSP		: std_logic_vector(31 downto 0);			
				
			signal MASTER_ActuationSP1Time : std_logic_vector(31 downto 0);
			signal MASTER_ActuationMinTime : std_logic_vector(31 downto 0);
			signal MASTER_ActuationTime	 : std_logic_vector(31 downto 0);
			
			signal MASTER_NotifyRegister	 : std_logic_vector(31 downto 0);
			
			signal MASTER_Sp1MaxTime		: std_logic_vector(31 downto 0);
			signal MASTER_Sp1MinTime		: std_logic_vector(31 downto 0);
			signal MASTER_MinPosMaxTime	: std_logic_vector(31 downto 0);
			signal MASTER_MinPosMinTime	: std_logic_vector(31 downto 0);
			signal MASTER_MinPosMaxValue	: std_logic_vector(31 downto 0);
			signal MASTER_MinPosMinValue	: std_logic_vector(31 downto 0);
			signal MASTER_ActMaxTime		: std_logic_vector(31 downto 0);
			signal MASTER_ActMinTime		: std_logic_vector(31 downto 0);		
			signal MASTER_BPSErrors			: std_logic_vector(31 downto 0);
			signal MASTER_BPSErrorData		: std_logic_vector(31 downto 0);
			signal MASTER_PCCounter			: std_logic_vector(31 downto 0);
			
			signal MASTER_ActuationSp1MaxTime		: std_logic_vector(31 downto 0);
			signal MASTER_ActuationSp1MinTime		: std_logic_vector(31 downto 0);		
			signal MASTER_ActuationMinPosMaxTime	: std_logic_vector(31 downto 0);		
			signal MASTER_ActuationMinPosMinTime	: std_logic_vector(31 downto 0);		
			signal MASTER_ActuationMinPosMaxValue	: std_logic_vector(31 downto 0);		
			signal MASTER_ActuationMinPosMinValue	: std_logic_vector(31 downto 0);		
			signal MASTER_ActuationActMaxTime		: std_logic_vector(31 downto 0);		
			signal MASTER_ActuationActMinTime		: std_logic_vector(31 downto 0);

			-- Additional registers for setting gains via SPI
			signal MASTER_ChannelGains 				: std_logic_vector(31 downto 0);
			--signal MASTER_ChAGain 			: std_logic_vector(31 downto 0);
			--signal MASTER_ChBGain 			: std_logic_vector(31 downto 0);
			--signal MASTER_IndxGain 			: std_logic_vector(31 downto 0);
			
			-- These form part of the actuation data
			signal MASTER_ActuationChAOutput 	: std_logic_vector(31 downto 0);
			signal MASTER_ActuationChBOutput		: std_logic_vector(31 downto 0);
			signal MASTER_ActuationIndxOutput	: std_logic_vector(31 downto 0);	
			
			signal MASTER_Engineering				: std_logic_vector(31 downto 0);
			signal MASTER_CaptureBoost				: std_logic_vector(31 downto 0);
			
			signal MASTER_Velocity					: std_logic_vector(31 downto 0);
			
			-- Miscellaneous signals
			signal BPS_RELAY_1_signal			: std_logic;
			signal BPS_RELAY_2_signal			: std_logic;
			signal BPS_RELAY_3_signal			: std_logic;
			
			signal LASER_RELAY_1_signal			: std_logic;
			signal LASER_RELAY_2_signal			: std_logic;
			signal LASER_RELAY_3_signal			: std_logic;

begin

	-- Instantiate  controller_Phase2
	Controller_Phase2b: entity work.controller_phase2b(arch)
	Port map
			(
			int_sysclk 						=> MASTER_clk,					--: in  std_logic;
         int_logic_reset				=> MASTER_reset,				--: in  std_logic;
				
			C_I_ch_a							=> C_I_ch_a,					--: in std_logic;
			C_I_ch_b							=> C_I_ch_b,					--: in std_logic;
			C_I_index						=> C_I_index,					--: in std_logic;
			
			C_I_key_en						=> C_I_key_en,					--: in std_logic;
			C_I_isis_ms						=> C_I_isis_ms,				--: in std_logic;
			C_I_mice_daq_ok				=> C_I_mice_daq_ok,			--: in std_logic;
			C_I_tgt_frame_raised			=> C_I_tgt_frame_raised,	--: in std_logic;
			C_I_tgt_frame_lowered 		=> C_I_tgt_frame_lowered,	--: in std_logic;
			
			C_I_Function_1_5V				=> C_I_Function_1_5V,		
			
			C_I_interlock_1_5v			=> C_I_interlock_1_5v,		--: in std_logic; 
			C_I_interlock_2_5v			=> C_I_interlock_2_5v,		--: in std_logic; 
			C_I_interlock_3_5v			=> C_I_interlock_3_5v,		--: in std_logic; 
			C_I_interlock_4_5v			=> C_I_interlock_4_5v,		--: in std_logic; 
			
			--C_I_interlock_1_24v			=> C_I_interlock_1_24v,		--: in std_logic; 
			--C_I_interlock_2_24v			=> C_I_interlock_2_24v,		--: in std_logic;
			C_I_interlock_3_24v			=> C_I_interlock_3_24v,		--: in std_logic;
			C_I_interlock_4_24v			=> C_I_interlock_4_24v,		--: in std_logic;
			
			C_I_USB_nc						=> usb_nc,						--: in std_logic
			
			C_O_ChA_LED						=> C_O_ChA_LED,
			C_O_ChB_LED						=> C_O_ChB_LED,
			C_O_Indx_LED					=> C_O_Indx_LED,
			
			C_O_mosfet						=> C_O_mosfet,					--: out std_logic_vector(6 downto 1);
			C_O_mosfet_led					=> C_O_mosfet_led,			--: out std_logic_vector(6 downto 1);
			C_O_target_pos					=> C_O_target_pos,			--: out std_logic_vector(8 downto 0);			
						
			C_O_tgt_ready_50r				=> C_O_tgt_ready_50r,		--: out std_logic;
			
			C_O_parked_led					=> C_O_parked_led,			--: out std_logic;
			C_O_hold_led					=> C_O_hold_led,				--: out std_logic;
			C_O_sys_en_led					=> C_O_sys_en_led,			--: out std_logic;
			C_O_actuate_en_led			=> C_O_actuate_en_led,		--: out std_logic;
			C_O_tgt_ready_led				=> C_O_tgt_ready_led,		--: out std_logic;
			C_O_actuating_led				=> C_O_actuating_led,		--: out std_logic;
			C_O_frame_raised_led			=> C_O_frame_raised_led,	--: out std_logic;
			C_O_frame_lowered_led 		=> C_O_frame_lowered_led,	--: out std_logic;		
			C_O_error_led					=> C_O_error_led,				--: out std_logic;
			
			C_O_actuating_50r_1			=> C_O_actuating_50r_1,		--: out std_logic;
			C_O_actuating_50r_2			=> C_O_actuating_50r_2,		--: out std_logic;
			C_O_actuating_50r_3			=> C_O_actuating_50r_3,		--: out std_logic;
			
			C_O_actuating_trig_50r_1	=> C_O_actuating_trig_50r_1,	--: out std_logic;
			C_O_actuating_trig_50r_2	=> C_O_actuating_trig_50r_2,	--: out std_logic;
			
			C_O_trig_accept_50r			=> C_O_trig_accept_50r,		--: out std_logic;
			
			C_O_Frame_Enable_50r			=> C_O_Frame_Enable_50r,	--: out std_logic;
			C_O_Legal_Spill_50r			=> C_O_Legal_Spill_50r,		--: out std_logic;
			--C_O_unused3						=> C_O_unused3,				--: out std_logic;
			
			C_O_DAQ_tx_dout				=> C_O_DAQ_tx_dout,
			C_O_DAQ_tx_sclk				=> C_O_DAQ_tx_sclk,
			C_O_DAQ_tx_synch				=> C_O_DAQ_tx_synch,
			
			C_O_ChA_Epot_tx_dout			=> C_O_ChA_Epot_tx_dout,
			C_O_ChA_Epot_tx_sclk			=> C_O_ChA_Epot_tx_sclk,
			C_O_ChA_Epot_tx_synch		=> C_O_ChA_Epot_tx_synch,
			
			C_O_ChB_Epot_tx_dout			=> C_O_ChB_Epot_tx_dout,	
			C_O_ChB_Epot_tx_sclk			=> C_O_ChB_Epot_tx_sclk,
			C_O_ChB_Epot_tx_synch		=> C_O_ChB_Epot_tx_synch,
			
			C_O_Indx_Epot_tx_dout		=> C_O_Indx_Epot_tx_dout,
			C_O_Indx_Epot_tx_sclk		=> C_O_Indx_Epot_tx_sclk,
			C_O_Indx_Epot_tx_synch		=> C_O_Indx_Epot_tx_synch,
			
			C_I_ChA_ADC_rx_din			=>	C_I_ChA_ADC_rx_din,
			C_O_ChA_ADC_rx_sclk			=> C_O_ChA_ADC_rx_sclk,
			C_O_ChA_ADC_rx_synch			=> C_O_ChA_ADC_rx_synch,
			
			C_I_ChB_ADC_rx_din			=>	C_I_ChB_ADC_rx_din,
			C_O_ChB_ADC_rx_sclk			=> C_O_ChB_ADC_rx_sclk,
			C_O_ChB_ADC_rx_synch			=> C_O_ChB_ADC_rx_synch,
			
			C_I_Indx_ADC_rx_din			=> C_I_Indx_ADC_rx_din,
			C_O_Indx_ADC_rx_sclk			=> C_O_Indx_ADC_rx_sclk,
			C_O_Indx_ADC_rx_synch		=> C_O_Indx_ADC_rx_synch,
			
			C_O_Spare_2_50R				=> C_O_Spare_2_50R,
			C_O_Spare_3_50R				=> C_O_Spare_3_50R,
			
			C_O_BPS_50R						=> C_O_BPS_50R,
			C_O_BPS_RELAY_1				=> BPS_RELAY_1_signal,
			C_O_BPS_RELAY_2				=> BPS_RELAY_2_signal,
			C_O_BPS_RELAY_3				=> BPS_RELAY_3_signal,
			
			C_O_LASER_RELAY_1				=> LASER_RELAY_1_signal,
			C_O_LASER_RELAY_2				=> LASER_RELAY_2_signal,
			C_O_LASER_RELAY_3				=> LASER_RELAY_3_signal,
			
			C_O_FRAME_EN_RELAY			=> C_O_FRAME_EN_RELAY,
			C_O_SPARE_RELAY				=> C_O_SPARE_RELAY,
				
			--USB Register Signals
			USB_ControlReg					=> MASTER_ControlReg,			--: inout std_logic_vector(31 downto 0);
			USB_SP1Wide						=> MASTER_SP1Wide,				--: inout std_logic_vector(31 downto 0)
			USB_MTH_Timer					=> MASTER_MTH_Timer,				--: in std_logic_vector(31 downto 0
			USB_HoldPosMax					=> MASTER_HoldPosMax,			--: in std_logic_vector(31 downto 0);
			USB_PWMSetup					=> MASTER_PWMSetup,				--: in std_logic_vector(31 downto 0);
			USB_WDTValue					=> MASTER_WDTValue,				--: in std_logic_vector(31 downto 0);
			USB_ISISDelay1					=> MASTER_ISISDelay1,			--: in std_logic_vector(31 downto 0);
			USB_ISISDelay2					=> MASTER_ISISDelay2,			--: in std_logic_vector(31 downto 0);
			USB_ErrorCorrection			=> MASTER_ErrorCorrection,		--: in std_logic_vector(31 downto 0); -- Includes ECCountMax ECThreshold and DefaultOffset
			USB_CapSettleTime				=> MASTER_CapSettleTime,		--: in std_logic_vector(31 downto 0);
			USB_CapWaitTime				=> MASTER_CapWaitTime,			--: in std_logic_vector(31 downto 0);
			USB_QCSetup						=> MASTER_QCSetup,				--: in std_logic_vector(31 downto 0); -- Includes QC InitialPos and QCIndexOffset
			USB_DeadTime					=> MASTER_DeadTime,				--: in std_logic_vector(31 downto 0);
			USB_KickBackTime				=> MASTER_KickBackTime,			--: in std_logic_vector(31 downto 0)	
			USB_DropLimit					=> MASTER_DropLimit,				--: in std_logic_vector(31 downto 0)				
			USB_LegalSpillDelay			=> MASTER_LegalSpillDelay,
			USB_ResetRegister				=> MASTER_ResetRegister,
			
			USB_StatusRegister			=> MASTER_StatusRegister,
			USB_ActuationMinMax			=> MASTER_ActuationMinMax, 	--: out std_logic_vector(31 downto 0);
			USB_ActuationCount			=> MASTER_ActuationCount,		--: out std_logic_vector(31 downto 0);
			USB_ActuationError			=> MASTER_ActuationError,		--: out std_logic_vector(31 downto 0);
			USB_ActuationSP				=> MASTER_ActuationSP,		 	--: out std_logic_vector(31 downto 0);

			USB_ActuationSP1Time			=> MASTER_ActuationSP1Time,	--: out std_logic_vector(31 downto 0);
			USB_ActuationMinTime			=> MASTER_ActuationMinTime,	--: out std_logic_vector(31 downto 0);
			USB_ActuationTime				=> MASTER_ActuationTime, 		--: out std_logic_vector(31 downto 0);

			USB_NotifyRegister			=> MASTER_NotifyRegister,		--: out std_logic_vector(31 downto 0)			
			
			USB_Sp1MaxTime					=> MASTER_Sp1MaxTime,
			USB_Sp1MinTime					=> MASTER_Sp1MinTime,
			USB_MinPosMaxTime				=> MASTER_MinPosMaxTime,
			USB_MinPosMinTime				=> MASTER_MinPosMinTime,
			USB_MinPosMaxValue			=> MASTER_MinPosMaxValue,
			USB_MinPosMinValue			=> MASTER_MinPosMinValue,
			USB_ActMaxTime					=> MASTER_ActMaxTime,
			USB_ActMinTime					=> MASTER_ActMinTime,
			
			USB_BPSErrors					=> MASTER_BPSErrors,
			USB_BPSErrorData				=> MASTER_BPSErrorData,
			
			USB_PCCounter					=> MASTER_PCCounter,
			
			-- BPS registers that are part of the actuation fifo
			-- That way the correct BPS values are aligned with the
			-- appropriate actuations
			USB_ActuationSp1MaxTime			=> MASTER_ActuationSp1MaxTime,
			USB_ActuationSp1MinTime			=> MASTER_ActuationSp1MinTime,		
			USB_ActuationMinPosMaxTime		=> MASTER_ActuationMinPosMaxTime,		
			USB_ActuationMinPosMinTime		=> MASTER_ActuationMinPosMinTime,		
			USB_ActuationMinPosMaxValue	=> MASTER_ActuationMinPosMaxValue,		
			USB_ActuationMinPosMinValue	=> MASTER_ActuationMinPosMinValue,		
			USB_ActuationActMaxTime			=> MASTER_ActuationActMaxTime,		
			USB_ActuationActMinTime			=> MASTER_ActuationActMinTime,

			-- Additional registers for setting gains via SPI
			USB_ChannelGains		=> MASTER_ChannelGains,
			--USB_ChAGain 			=> MASTER_ChAGain,
			--USB_ChBGain 			=> MASTER_ChBGain,
			--USB_IndxGain 			=> MASTER_IndxGain,
			
			-- These form part of the actuation data
			USB_ActuationChAOutput 		=> MASTER_ActuationChAOutput,
			USB_ActuationChBOutput		=> MASTER_ActuationChBOutput,
			USB_ActuationIndxOutput		=> MASTER_ActuationIndxOutput,
			USB_Engineering				=> MASTER_Engineering,
			USB_CaptureBoost				=> MASTER_CaptureBoost,	

			USB_Velocity					=> MASTER_Velocity
			);
	
	-- Instantiate USB
	USB_Module_Phase2b: entity work.usb_module_phase2b(arch)
	Port map
			(
			clk 					=> clk,						--: in  STD_LOGIC;
         reset 				=> reset,					--: in  STD_LOGIC;			
			--
			-- Usb interface
			--
			sx2_ifclk			=> sx2_ifclk,				--: out		std_logic;
			sx2_int				=> sx2_int,					--: in		std_logic;
			sx2_ready			=> sx2_ready,				--: in		std_logic;
			sx2_reset			=> sx2_reset,				--: out		std_logic;
			sx2_sloe				=> sx2_sloe,				--: out		std_logic;
			sx2_slrd				=> sx2_slrd,				--: out		std_logic;
			sx2_slwr				=> sx2_slwr,				--: out		std_logic;
			sx2_pkt_end			=> sx2_pkt_end,			--: out		std_logic;
			sx2_fifo_address	=> sx2_fifo_address, 	--: out		std_logic_vector(2 downto 0);
			sx2_flag_a			=> sx2_flag_a,				--: in		std_logic;
			sx2_flag_b			=> sx2_flag_b,				--: in		std_logic;
			sx2_flag_c			=> sx2_flag_c,				--: in		std_logic;
			sx2_wakeup			=> sx2_wakeup,				--: out		std_logic;
			sx2_n_cs				=> sx2_n_cs,				--: out		std_logic;
			sx2_fifo_data		=> sx2_fifo_data,			--: inout	std_logic_vector(15 downto 0);
			usb_nc				=> usb_nc,					--: in		std_logic;
			
			--
			-- User Register Signals
			--
			int_sysclk 				=> MASTER_clk,						--: out std_logic;
			int_logic_reset		=> MASTER_reset,					--: out std_logic;
			sx2_ControlReg			=> MASTER_ControlReg,			--: out std_logic_vector(31 downto 0);
			sx2_SP1Wide				=> MASTER_SP1Wide,				--: out std_logic_vector(31 downto 0);
			sx2_MTH_Timer			=> MASTER_MTH_Timer,
			sx2_HoldPosMax			=> MASTER_HoldPosMax,			--: std_logic_vector(31 downto 0);
			sx2_PWMSetup			=> MASTER_PWMSetup,				--: std_logic_vector(31 downto 0);
			sx2_WDTValue			=> MASTER_WDTValue,				--: std_logic_vector(31 downto 0);
			sx2_ISISDelay1			=> MASTER_ISISDelay1,			--: std_logic_vector(31 downto 0);
			sx2_ISISDelay2			=> MASTER_ISISDelay2,			--: std_logic_vector(31 downto 0);
			sx2_ErrorCorrection	=> MASTER_ErrorCorrection,		--: std_logic_vector(31 downto 0); -- Includes ECCountMax ECThreshold and DefaultOffset
			sx2_CapSettleTime		=> MASTER_CapSettleTime,		--: std_logic_vector(31 downto 0);
			sx2_CapWaitTime		=> MASTER_CapWaitTime,			--: std_logic_vector(31 downto 0);
			sx2_QCSetup				=> MASTER_QCSetup,				--: std_logic_vector(31 downto 0); -- Includes QC InitialPos and QCIndexOffset
			sx2_DeadTime			=> MASTER_DeadTime,				--: std_logic_vector(31 downto 0);
			sx2_KickBackTime		=> MASTER_KickBackTime,			--: std_logic_vector(31 downto 0)
			sx2_DropLimit			=> MASTER_DropLimit,				--: out std_logic_vector(31 downto 0)				
			sx2_LegalSpillDelay	=> MASTER_LegalSpillDelay,		
			sx2_ResetRegister		=> MASTER_ResetRegister,
			
			sx2_StatusRegister	=> MASTER_StatusRegister,
			sx2_ActuationMinMax	=> MASTER_ActuationMinMax, 	--: out std_logic_vector(31 downto 0);
			sx2_ActuationCount	=> MASTER_ActuationCount,		--: out std_logic_vector(31 downto 0);
			sx2_ActuationError	=> MASTER_ActuationError,		--: out std_logic_vector(31 downto 0);
			sx2_ActuationSP		=> MASTER_ActuationSP,		 	--: out std_logic_vector(31 downto 0);
			
			sx2_ActuationSP1Time =>	MASTER_ActuationSP1Time, 	--: std_logic_vector(31 downto 0);
			sx2_ActuationMinTime	=>	MASTER_ActuationMinTime, 	--: std_logic_vector(31 downto 0);
			sx2_ActuationTime		=>	MASTER_ActuationTime,	 	--: std_logic_vector(31 downto 0);	
			sx2_NotifyRegister	=> MASTER_NotifyRegister,
			
			sx2_Sp1MaxTime			=> MASTER_Sp1MaxTime,
			sx2_Sp1MinTime			=> MASTER_Sp1MinTime,
			sx2_MinPosMaxTime		=> MASTER_MinPosMaxTime,
			sx2_MinPosMinTime		=> MASTER_MinPosMinTime,
			sx2_MinPosMaxValue	=> MASTER_MinPosMaxValue,
			sx2_MinPosMinValue	=> MASTER_MinPosMinValue,
			sx2_ActMaxTime			=> MASTER_ActMaxTime,
			sx2_ActMinTime			=> MASTER_ActMinTime,
			
			sx2_BPSErrors			=> MASTER_BPSErrors,
			sx2_BPSErrorData		=> MASTER_BPSErrorData,
			
			sx2_PCCounter			=> MASTER_PCCounter,
			-- BPS registers that are part of the actuation fifo
			-- That way the correct BPS values are aligned with the
			-- appropriate actuations
			sx2_ActuationSp1MaxTime			=> MASTER_ActuationSp1MaxTime,
			sx2_ActuationSp1MinTime			=> MASTER_ActuationSp1MinTime,		
			sx2_ActuationMinPosMaxTime		=> MASTER_ActuationMinPosMaxTime,		
			sx2_ActuationMinPosMinTime		=> MASTER_ActuationMinPosMinTime,		
			sx2_ActuationMinPosMaxValue	=> MASTER_ActuationMinPosMaxValue,		
			sx2_ActuationMinPosMinValue	=> MASTER_ActuationMinPosMinValue,		
			sx2_ActuationActMaxTime			=> MASTER_ActuationActMaxTime,		
			sx2_ActuationActMinTime			=> MASTER_ActuationActMinTime,

			-- Additional registers for setting gains via SPI
			sx2_ChannelGains 					=> MASTER_ChannelGains,
			--sx2_ChAGain 			=> MASTER_ChAGain,
			--sx2_ChBGain 			=> MASTER_ChBGain,
			--sx2_IndxGain 		=> MASTER_IndxGain,
			
			-- These form part of the actuation data
			sx2_ActuationChAOutput 		=> MASTER_ActuationChAOutput,
			sx2_ActuationChBOutput		=> MASTER_ActuationChBOutput,
			sx2_ActuationIndxOutput		=> MASTER_ActuationIndxOutput,
			
			--
			sx2_Engineering				=> MASTER_Engineering,
			sx2_CaptureBoost				=> MASTER_CaptureBoost,
			
			sx2_Velocity					=> MASTER_Velocity
			);
			
			reset_led <= MASTER_reset;
			
			C_O_LED_R7 <= not (MASTER_reset);
			
			C_O_LED1 <= not (BPS_RELAY_1_signal);
			C_O_LED2 <= not (BPS_RELAY_2_signal);
			C_O_LED3 <= not (BPS_RELAY_3_signal);
			
			C_O_BPS_RELAY_1 	<= BPS_RELAY_1_signal;
			C_O_BPS_RELAY_2 	<= BPS_RELAY_2_signal;
			C_O_BPS_RELAY_3 	<= BPS_RELAY_3_signal;
			
			C_O_LED4 <= not (LASER_RELAY_1_signal);
			C_O_LED5 <= not (LASER_RELAY_2_signal);
			C_O_LED6 <= not (LASER_RELAY_3_signal);
			
			C_O_LASER_RELAY_1 	<= LASER_RELAY_1_signal;
			C_O_LASER_RELAY_2 	<= LASER_RELAY_2_signal;
			C_O_LASER_RELAY_3 	<= LASER_RELAY_3_signal;
			
end arch;

