----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:31:31 03/09/2010 
-- Design Name: 
-- Module Name:    Binary_Counter - arch 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Binary_Counter is
    Port (
			BC_I_clk 			: in  STD_LOGIC;
         BC_I_reset 			: in  STD_LOGIC;
			BC_I_ResetCounter	: in std_logic;
			
			BC_O_CountValue	: out std_logic_vector(31 downto 0)
			);
end Binary_Counter;

architecture arch of Binary_Counter is

	signal CountValueNow 	: unsigned(31 downto 0);
	signal CountValueNext	: unsigned(31 downto 0);

begin

	BC_O_CountValue <= std_logic_vector(CountValueNow);

	process(BC_I_clk, BC_I_reset)
	begin
		if (BC_I_reset = '1') then
			CountValueNow	<= (others => '0');
		elsif (BC_I_clk'event and BC_I_clk = '1') then
			CountValueNow <= CountValueNext;
		end if;
	end process;

	process(BC_I_ResetCounter, CountValueNow)
	begin
		if (BC_I_ResetCounter = '1') Then
			CountValueNext <= (Others => '0');
		else
			CountValueNext <= CountValueNow + 1;
		end if;
	end process;

end arch;

