-----------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
-----------------------------------------------------------


-- Entity
-----------------------------------------------------------
entity edge_detector is
	port(
		I_rst			: in	std_logic;
		I_clk			: in	std_logic;
		--
		I_enable		: in	std_logic;
		I_edge_type	: in	std_logic;
		--
		I_data_in	: in	std_logic;
		O_edge_out	: out	std_logic
	);
end entity edge_detector;

-- Architecture
-----------------------------------------------------------
architecture v0 of edge_detector is
	
	-- Signals
	-----------------------------
	
	signal SA_data_in_prev : std_logic;
	
begin
	
	-- Processes
	-----------------------------

	detect: process(I_rst, I_clk)
	begin
		
		if(I_rst = '1') then
			
			SA_data_in_prev <= '0';
			O_edge_out <= '0';
			
		elsif(I_clk'event and I_clk = '1') then
			
			if((SA_data_in_prev = not(I_edge_type)) and (I_data_in = I_edge_type) and (I_enable = '1')) then
				O_edge_out <= '1';
			else
				O_edge_out <= '0';
			end if;
			
			SA_data_in_prev <= I_data_in;
			
		end if;
		
	end process detect;
	
end architecture v0;
