----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:33:20 10/06/2009 
-- Design Name: 
-- Module Name:    Hold_State_Switch - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Hold_State_Switch is
    Port ( 			
			MS_I_enable				: in std_logic;
			MS_I_HoldSelect1		: in std_logic;
			MS_I_HoldSelect2		: in std_logic;

			MS_I_HOLD1				: in std_logic_vector(5 downto 0);
			MS_I_HOLD2				: in std_logic_vector(5 downto 0);
			
			MS_O_HOLD				: out std_logic_vector(5 downto 0)

			);
end Hold_State_Switch;

architecture arch of Hold_State_Switch is

	signal SA_HoldInt			: std_logic_vector(5 downto 0);

begin

	process (SA_HoldInt, MS_I_HoldSelect1, MS_I_HoldSelect2,
				MS_I_HOLD1, MS_I_HOLD2)
	begin
	
		if (MS_I_HoldSelect1 = '1') and (MS_I_HoldSelect2 = '0') then
			SA_HoldInt <= MS_I_HOLD1;
		elsif ((MS_I_HoldSelect1 = '0') and (MS_I_HoldSelect2 = '1')) then
			SA_HoldInt <= MS_I_HOLD2;
		else 
			SA_HoldInt <= (others => '0');
		end if;
		
	end process;
	
	
	process (MS_I_enable, SA_HoldInt)
	
	begin

		if (MS_I_enable = '1') then
			MS_O_HOLD <= SA_HoldInt;
		else 
			MS_O_HOLD <= (others => '0');
		end if;
		
	end process;

end arch;

