----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    09:52:01 10/20/2009 
-- Design Name: 
-- Module Name:    IndexCheck - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;

use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_Std.all;


---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity IndexCheck is
    Port ( 
			ERRCHK_I_clk 				: in  STD_LOGIC;
			ERRCHK_I_reset 			: in  STD_LOGIC;
			ERRCHK_I_ResetLatch		: in  std_Logic;
			ERRCHK_I_Index			: in  std_logic;
			ERRCHK_O_Latch			: out std_logic
			);
			
end IndexCheck;

architecture arch of IndexCheck is

			type TA_state_type is 	
								(
								State_1,
								State_2
								);
								
			signal TA_state_reg, TA_state_next: TA_state_type;

	


begin


	process(ERRCHK_I_clk, ERRCHK_I_reset)
			
			begin
			
				if (ERRCHK_I_reset = '1') then
					TA_state_reg <= State_1;
				elsif (ERRCHK_I_clk'event and ERRCHK_I_clk = '1') then
					TA_state_reg <= TA_state_next;
				end if;
				
			end process;
			
			process(TA_state_reg, ERRCHK_I_ResetLatch, ERRCHK_I_Index)
	
			begin
				
				TA_state_next <= TA_state_reg;
	
				case TA_state_reg is
				
				when State_1 =>
				
					-- This acknowledges that an index has been seen
					if (ERRCHK_I_ResetLatch = '0' and ERRCHK_I_Index = '1') then	
							TA_State_Next <= State_2;
							ERRCHK_O_Latch <='1';	
					else
							TA_State_Next <= State_1;
							ERRCHK_O_Latch <= '0';	
					end if;
					
				when State_2 =>
				
					if (ERRCHK_I_ResetLatch = '1' and ERRCHK_I_Index = '0') then
						TA_State_Next <= State_1;
						ERRCHK_O_Latch <= '0';	
					else
						TA_State_Next <= State_2;
						ERRCHK_O_Latch <='1';
					end if;
				
				end case;
				
			end process;

end arch;

