----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    10:59:14 10/26/2009 
-- Design Name: 
-- Module Name:    Interlocks - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
-- THIS INTERLOCK MODULE CAN GROW
-- AS NEEDS REQUIRE BUT FOR NOW
-- IT WILL REMAIN A FAIRLY SIMPLE
-- STUB PROVIDING THE NECESSARY 
-- CONNECTION MECHANISM.
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.numeric_std.all;
--use IEEE.STD_LOGIC_ARITH.ALL;
--use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity Interlocks is
    Port (
			clk						: in std_logic;
			reset						: in std_logic;
			
			INT_Frame_Raised		: in std_logic;
	 
			INT_I_Interlock1_5V	: in std_logic;
			INT_I_Interlock2_5V	: in std_logic;
			INT_I_Interlock3_5V	: in std_logic;
			INT_I_Interlock4_5V	: in std_logic;
			
			--INT_I_Interlock1_24V	: in std_logic;
			--INT_I_Interlock2_24V	: in std_logic;
			INT_I_Interlock3_24V	: in std_logic;
			INT_I_Interlock4_24V	: in std_logic;
			
			INT_O_Interlock_5V	: out std_logic;
			INT_O_Interlock_24V	: out std_logic;
			INT_O_5V_Tick			: out std_logic;
			INT_O_24V_Tick			: out std_logic;
			INT_O_PPS_Interlock	: out std_logic
			);
			
end Interlocks;

architecture arch of Interlocks is

	signal SumInt1_5V			: std_logic;
	signal SumInt1_24V		: std_logic;
	
	signal NOTSumInt1_5V		: std_logic;
	signal NOTSumInt1_24V	: std_logic;
	
	signal sl_DG_Int3_24V	: std_logic;
	signal sl_DG_Int4_24V	: std_logic;
	
	signal sl_DG_Int1_5V		: std_logic;
	signal sl_DG_Int2_5V		: std_logic;
	signal sl_DG_Int3_5V		: std_logic;
	signal sl_DG_Int4_5V		: std_logic;
	
	signal PPS_Interlock		: std_logic;
	
	
	constant CA_filter_bit_width	: positive range 2 to integer'high := 4;

begin
	
	-- Try adding glitch removal to all of the interlock inputs because the 
	-- interlock keeps creating an error??
	-- 02/11/2011
	
	Interlock3_24V: entity work.glitch_filter
		generic map(
			G_bit_width	=> CA_filter_bit_width
		)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_data_in	=> INT_I_Interlock3_24V,
			O_data_out	=> sl_DG_Int3_24V
		);
		
	Interlock4_24V: entity work.glitch_filter
		generic map(
			G_bit_width	=> CA_filter_bit_width
		)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_data_in	=> INT_I_Interlock4_24V,
			O_data_out	=> sl_DG_Int4_24V
		);
		
	Interlock1_5V: entity work.glitch_filter
		generic map(
			G_bit_width	=> CA_filter_bit_width
		)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_data_in	=> INT_I_Interlock1_5V,
			O_data_out	=> sl_DG_Int1_5V
		);
		
	Interlock2_5V: entity work.glitch_filter
		generic map(
			G_bit_width	=> CA_filter_bit_width
		)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_data_in	=> INT_I_Interlock2_5V,
			O_data_out	=> sl_DG_Int2_5V
		);
		
	Interlock3_5V: entity work.glitch_filter
		generic map(
			G_bit_width	=> CA_filter_bit_width
		)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_data_in	=> INT_I_Interlock3_5V,
			O_data_out	=> sl_DG_Int3_5V
		);
		
	Interlock4_5V: entity work.glitch_filter
		generic map(
			G_bit_width	=> CA_filter_bit_width
		)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_data_in	=> INT_I_Interlock4_5V,
			O_data_out	=> sl_DG_Int4_5V
		);


	-- Summed Interlock signal - 5V
	Interlock_5V_Tick: entity work.edge_detector(v0)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_enable		=> '1',
			I_edge_type	=> '1',
			--
			I_data_in	=> NOTSumInt1_5V,
			--I_data_in	=> SumInt1_5V,
			O_edge_out	=> INT_O_5V_Tick
		);
	
	-- Summed Interlock signal - 24V	
	Interlock_24V_Tick: entity work.edge_detector(v0)
		port map(
			I_rst			=> reset,
			I_clk			=> clk,
			--
			I_enable		=> '1',
			I_edge_type	=> '1',
			--
			I_data_in	=> NOTSumInt1_24V,
			O_edge_out	=> INT_O_24V_Tick
		);

	NOTSumInt1_5V <= not(SumInt1_5V);
	NOTSumInt1_24V <= not(SumInt1_24V);

	-- Defined so that 
	-- Output of '1' means that the interlock is ok.
	-- Logic will need changing if any interlocks are used!
	SumInt1_5V <= NOT(sl_DG_Int1_5V OR sl_DG_Int2_5V
						OR sl_DG_Int3_5V OR sl_DG_Int4_5V);
						
	--SumInt1_24V <= NOT(INT_I_Interlock1_24V OR INT_I_Interlock2_24V
	--					OR INT_I_Interlock3_24V OR INT_I_Interlock4_24V);
	
	-- Defined so that 
	-- Output of '1' means that the interlock is ok.
	
	--Frigged out 21/11/2011 until role of PPS interlock is properly defined!
	--PPS_Interlock	<=  sl_DG_Int3_24V;
	PPS_Interlock <= '1';
	
	-- The 24V interlock is good providing the frame is raised OR the PPS is good!
	-- DG = Deglitched
	SumInt1_24V <= (INT_FRAME_RAISED OR PPS_Interlock) AND (NOT sl_DG_Int4_24V);
	-- Note that if interlock4_24V is used then this should be changed to:
	--SumInt1_24V <= PPS_Interlock AND (sl_DG_Int4_24V);
	
	
	
	INT_O_Interlock_5V<= SumInt1_5V;
	INT_O_Interlock_24V <= SumInt1_24V;
	INT_O_PPS_Interlock <= PPS_Interlock;
	--INT_O_Interlock_5V	<= '1';
	--INT_O_Interlock_24V <= '1';
	
end arch;

