----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:45:23 02/13/2009 
-- Design Name: 
-- Module Name:    mod_m_counter - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

entity mod_m_counter is

	Generic	(
				N: integer :=4
				);
				
    Port 	(
				clk 			: in  std_logic;
				reset 		: in  std_logic;
				synch			: in  std_logic;
				timer_max	: in std_logic_vector(N-1 downto 0);
				
				max_tick		: out std_logic;
				q				: out std_logic_vector(N-1 downto 0)
				);
end mod_m_counter;

architecture arch of mod_m_counter is

	signal r_reg: 	unsigned(N-1 downto 0);
	signal r_next:	unsigned(N-1 downto 0);
	signal r_max : unsigned(N-1 downto 0);

begin
	
	r_max <= unsigned(timer_max);	
	
	-- register
	process (clk, reset)
	begin
		if (reset = '1') then
			r_reg <= (others => '0');
		elsif (clk'event and clk = '1') then
			if (synch = '1') then
				r_reg <= (others => '0');
			else
				r_reg <= r_next;
			end if;
		end if;
	end process;
	
	-- next state logic
	r_next <= (others => '0') when r_reg = (r_max-1) else
		r_reg + 1;
	
	-- output logic
	q <= std_logic_vector(r_reg);
	max_tick <= '1' when r_reg = (r_max-1) else '0';

end arch;

