----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    22:24:17 09/19/2010 
-- Design Name: 
-- Module Name:    mod_n_counter_en_001 - arch
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity mod_n_counter_en_001 is
	generic	(
				g_counter_bits		: integer:= 3;
				g_modulus			: integer:= 7  
				);
	port ( 
			clk 					: in  std_logic;
         reset 				: in  std_logic;
			
			i_en					: in std_logic;
			i_reset_counters	: in std_logic;
			
			o_tick				: out std_logic;
			o_square 			: out std_logic
			);
			
end mod_n_counter_en_001;

architecture arch of mod_n_counter_en_001 is

	signal u_counter_now		: unsigned(g_counter_bits-1 downto 0);
	signal u_counter_next	: unsigned(g_counter_bits-1 downto 0);
	
	signal sl_tick_now		: std_logic;
	signal sl_tick_next		: std_logic;	
	
	signal q_now				: std_logic;
	signal q_next				: std_logic;
	
	

begin

	process(clk, reset)
			
	begin
			
		if (reset = '1') then
			u_counter_now <= (others => '0');
			q_now <= '1';
			sl_tick_now <= '0';
			
		elsif (clk'event and clk = '1') then
		
			if (i_reset_counters = '1') then 
				u_counter_now <= (others => '0');
				q_now <= '1';
				sl_tick_now <= '0';
					
			else
				--if (i_en = '1') then	
				
				sl_tick_now <= sl_tick_next;
				u_counter_now <= u_counter_next;
				q_now <= q_next;
				
				--end if;
				
			end if;
			
		end if;
				
	end process;
	
	process(u_counter_now, i_en)
	
	begin
	
		sl_tick_next <= '0';
		
		if (i_en = '1') then
		
			if u_counter_now = (g_modulus - 1) then 
				sl_tick_next <= '1';
			end if;
		end if;
		
	end process;
						
	--sl_tick_next <= '1' when (u_counter_now = (g_modulus - 1)) else
	--					'0';
	
	process(u_counter_now, sl_tick_next, q_now, i_en)
	
	begin
		q_next <= q_now;
		u_counter_next <= u_counter_now;
		if (i_en = '1') then
			u_counter_next <= u_counter_now + 1;
			if (sl_tick_next = '1') then
				u_counter_next <= (others => '0');
				q_next <= not (q_now);
			end if;		
		end if;
		
	end process;
	
	--u_counter_next <= (others => '0') when sl_tick_next = '1' else
	--						(u_counter_now + 1);
	
	--q_next <= not (q_now);
	o_tick <= sl_tick_now and q_now;
	o_square <= q_now; 
		
end arch;

