----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:58:50 07/10/2009 
-- Design Name: 
-- Module Name:    MOSFET_Switch - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity MOSFET_Switch is

    Port ( 
			--MS_I_clk 				: in STD_LOGIC;
         --MS_I_reset 				: in STD_LOGIC;
			
			MS_I_enable				: in std_logic;
			MS_I_hold_select		: in std_logic;
			MS_I_actuate_select	: in std_logic;
			
			MS_I_pwm_in				: in std_logic;

			MS_I_MOSFET_hold		: in std_logic_vector(6 downto 1);
			MS_I_MOSFET_actuate	: in std_logic_vector(6 downto 1);
			
			MS_O_MOSFET				: out std_logic_vector(6 downto 1);
			MS_O_MOSFETLED			: out std_logic_vector(6 downto 1)
			
			);
			
end MOSFET_Switch;


architecture arch of MOSFET_Switch is

	signal SA_MOSFET_int			: std_logic_vector(6 downto 1);
	signal SA_MOSFET_int_2		: std_logic_vector(6 downto 1);

	begin
	
	process (SA_MOSFET_int, MS_I_hold_select, MS_I_actuate_select,
				MS_I_MOSFET_actuate, MS_I_MOSFET_hold)
	begin
	
		if (MS_I_hold_select = '0') and (MS_I_actuate_select = '1') then
			SA_MOSFET_Int <= MS_I_MOSFET_Actuate;
		elsif ((MS_I_hold_select = '1') and (MS_I_actuate_select = '0')) then
			SA_MOSFET_Int <= MS_I_MOSFET_hold;
		else 
			SA_MOSFET_Int <= (others => '0');
		end if;
		
	end process;
	
	-- Here is where the pwm signal is mixed with the MOSFET signals
	SA_MOSFET_int_2(1) <= SA_MOSFET_int(1);
	SA_MOSFET_int_2(2) <= (SA_MOSFET_int(2) and MS_I_pwm_in);
	SA_MOSFET_int_2(3) <= SA_MOSFET_int(3);
	SA_MOSFET_int_2(4) <= (SA_MOSFET_int(4) and MS_I_pwm_in);
	SA_MOSFET_int_2(5) <= SA_MOSFET_int(5);
	SA_MOSFET_int_2(6) <= (SA_MOSFET_int(6) and MS_I_pwm_in);
	
	process (MS_I_enable, SA_MOSFET_Int_2, SA_MOSFET_int)
	
	begin

		if (MS_I_enable = '1') then
			MS_O_MOSFET <= SA_MOSFET_Int_2;
			MS_O_MOSFETLED <= SA_MOSFET_Int;
		else 
			MS_O_MOSFET <= (others => '0');
			MS_O_MOSFETLED <= (others => '0');
		end if;
		
	end process;
	
end arch;

