----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:15:54 07/13/2009 
-- Design Name: 
-- Module Name:    QC_Interface - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.numeric_std.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity QC_Interface is

    Port 	(
				QCI_I_clk 				: in  std_logic;
				QCI_I_reset 			: in  std_logic;
				QCI_I_RstToStart		: in  std_logic;
				
				QCI_I_cha				: in std_logic;
				QCI_I_chb				: in std_logic;
				QCI_I_index				: in std_logic;
				QCI_I_IndexEnable		: in std_logic;
				QCI_I_IndexDirection : in std_logic;
				
				QCI_ResetPosition		: in std_logic_vector(8 downto 0);
				QCI_IndexOffset		: in std_logic_vector(8 downto 0);
				--QCI_ResetError			: in  std_logic;
				
				QCI_O_direction		: out std_logic;
				QCI_O_position			: out std_logic_vector(8 downto 0);
				
				QCI_O_DeGlitchCHA		: out std_logic;
				QCI_O_DeGlitchCHB		: out std_logic;
				QCI_O_DeGlitchIndex	: out std_logic;
				
				QCI_O_ErrorFlag		: out std_logic;
				QCI_O_error				: out std_logic_vector(2 downto 0);
				QCI_O_error_value 	: out std_logic_vector(8 downto 0)
				);
				
end QC_Interface;

architecture arch of QC_Interface is

	--constant SA_reset_position : std_logic_vector(8 downto 0):= "000010000";
	--constant SA_index_offset : std_logic_vector(8 downto 0) := "101011001";

begin

	-- Instantiate James' Quadrature Counter
	Quad_Counter: entity work.quadrature_counter(arch)
	port map   (
					I_rst				=> QCI_I_reset,
					I_clk100k		=> QCI_I_clk,
					I_clk20m			=> QCI_I_clk,
					I_rstToStart	=> QCI_I_RstToStart,
					--
					I_rst_position	=> QCI_ResetPosition,
					I_index_offset	=> QCI_IndexOffset,
					--I_reset_error	=> QCI_ResetError,
					--
					I_ch_a			=> QCI_I_cha,
					I_ch_b			=> QCI_I_chb,
					I_index			=> QCI_I_index,
					I_IndexEnable	=> QCI_I_IndexEnable,
					I_indexDirection		=> QCI_I_IndexDirection,
					--
					O_position		=> QCI_O_position,
					O_direction		=> QCI_O_direction,
					
					O_DeGlitchCHA	=> QCI_O_DeGlitchCHA,
					O_DeGlitchCHB	=> QCI_O_DeGlitchCHB,
					O_DeGlitchIndex => QCI_O_DeGlitchIndex,
					--
					O_ErrorFlag		=> QCI_O_ErrorFlag,
					O_error			=> QCI_O_error,
					O_error_value	=> QCI_O_error_value
					);



end arch;

